// -------------------------------------- //
// Peng Guo, Indiana University, Jan.2015 //
// -------------------------------------- //

#include <iostream>
#include <fstream>
#include <iomanip>
#include <complex>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string>

#include "../amps_LIB/Amps/2bamp.h"





using namespace std;


int Imax, Lmax;


int main( int argc, char* argv[]  )
{
    int m1 = +1;
    int m2 = -1;
    int m3 = 0;
    
    int KTon = 0;
    string datafilename;

    
    if (argc != 4)
    {
        cout << " " << endl;
        cout << " Input Imax, Lmax. " << endl;
        cout << " Usage: ./2bamp <Imax>  <Lmax> <filename>. " << endl;
        cout << " " << endl;
        exit (1);
    }
    else
    {
        sscanf(argv[1],"%d",&Imax) ;
        sscanf(argv[2],"%d",&Lmax) ;
        datafilename = argv[3];
    }
    
    cout << endl;
    cout << "****************************************************" << endl;
    cout << "Inputs are: Imax=" << Imax<<", Lmax=" << Lmax << ", 3b="<<KTon<< ", process is: pi["<<m1<<"]+pi["<< m2<<"]+pi["<<m3<<"]." <<endl;
    cout << "****************************************************" << endl;
    cout << endl;
   
    

    
    
    // initializing //
    
    double meta = 0.549;
    double mpip = 0.13957;
    double mpim = 0.13957;
    double mpi0 = 0.13498;

    
    
    TwobodyAmp dalizplot;
    dalizplot.parameterspace(m1,m2,m3,Imax,Lmax);
    
    string inputfile = "./input_params/input_fitting_params.txt";
    struct param_space a0_IL;
    struct param_space *pa0_IL = &a0_IL ;
    
    dalizplot.parameters_ini(inputfile,m1,m2,m3,Imax,Lmax,pa0_IL);
    
    
    
    // computing amplitudes //
    ifstream readfilein(datafilename.c_str());
    if (readfilein.fail())
    {
        cout  << "Error Opening File: " << datafilename << endl;
        exit(1);
    }
    
    
 
    
    while (!readfilein.eof())
    {
        double  x,y;
        readfilein >> x >> y;
        
        
        if (readfilein.eof())
        {
            break;
        }
        
        complex<double>	 r = dalizplot.amp_xy(x,y,m1,m2,m3,Imax,Lmax,meta,mpip,mpim,mpi0,pa0_IL);;
        
        cout << x << " " << y << " " << real(r) << " " << imag(r) << endl;
        
        //cout << x << " " << y << " " << real(conj(r)*r)  << endl;

    }
    
    
    
 
}







// -------------------------------------- //
// Peng Guo, Indiana University, Jan.2015 //
// -------------------------------------- //




